Description

Patch #26655 has added icons to open the context menu on the issues list. The button is very helpful and I really like it. It would be

great if issues#show page has the same button as well. It allows users to update various fields (e.g. assignee, status, priority,

category, custom fields, ...) easily and quickly.

Assume that you are about to update the assignee field. In the current version, you need 4 clicks to complete the operation (click

"Edit", open "Assignee" drop-down, select a user, and click "Submit"). However, if the button is implemented, all you need is just  2

clicks ( click the context menu icon and then click a user).

I think the button greatly improves UX and productivity.

 

Related issues:

Related to Redmine - Patch #26655: Additional icon for contextmenu Closed

Related to Redmine - Feature #729: Issues: (semi-)inline issue editing New 2008-02-23

Related to Redmine - Feature #28086: Add context menu for attributes in issue... Closed

Related to Redmine - Feature #33153: UI feature to quickly change issue status New

Associated revisions

Revision 17354 - 2018-05-29 02:51 - Go MAEDA

Add right-click context menu to the contextual area of an issue (#28829).

Patch by Mizuki ISHIKAWA.

Revision 17491 - 2018-09-15 11:48 - Jean-Philippe Lang

Reverts r17354 (#28829).

History

#1 - 2018-05-21 15:58 - Go MAEDA

- Related to Patch #26655: Additional icon for contextmenu added

#2 - 2018-05-21 16:14 - Go MAEDA

- Related to Feature #729: Issues: (semi-)inline issue editing added
#3 - 2018-05-22 02:33 - Go MAEDA

- Related to Feature #28086: Add context menu for attributes in issue details added

#4 - 2018-05-22 03:35 - Mizuki ISHIKAWA

- File Add-context-menu-icon-on-issue.patch added

I attached a patch that realizes this feature.

I think it is very convenient to be able to change some items without opening the edit panel.

#5 - 2018-05-22 04:28 - Go MAEDA

- File 28829-screenshot@2x.png added

Mizuki, thank you for writing the patch so quickly.

This is a screenshot of the patch. Users can update various fields with the context menu, without moving to "Edit" form.

Issues list already has the 3-bullets button to show the context menu. I think that adding the button to the issue page is very reasonable and makes

the UI consistent.

 

#6 - 2018-05-22 05:06 - Go MAEDA

- File 28829-responsive-bug@2x.png added

I noticed the following points. Please check.

The patch works without icon-only-context-menu CSS class. We can pinpoint the icon with .contextual span.hascontextmenu.

The button looks ugly on mobile screens. Please see the screenshot below.
#7 - 2018-05-23 00:07 - Yuuki NARA

+1

I applied this patch and 26655 to my 3.4 environment.

LGTM

#8 - 2018-05-23 01:30 - Anonymous

+1!

#9 - 2018-05-23 07:43 - Mizuki ISHIKAWA

- File Add-context-menu-icon-on-issue-v2.patch added

Go MAEDA wrote:

I noticed the following points. Please check.

The patch works without icon-only-context-menu CSS class. We can pinpoint the icon with .contextual span.hascontextmenu.

The button looks ugly on mobile screens. Please see the screenshot below.

 I fixed about points you pointed out.

This feature seems to be wanted by many people.

Thank you for a great idea, Go MAEDA.

#10 - 2018-05-23 07:47 - Mizuki ISHIKAWA

- File Add-context-menu-icon-on-issue-v3.patch added

I fixed the test a little.

#11 - 2018-05-24 01:26 - Go MAEDA

- Target version set to Candidate for next major release

#12 - 2018-05-24 10:19 - Bernhard Rohloff

I also think that it makes sense to place the editing options inside the already existing contextual area. This is a place people already know and would

search for a feature like that. Good job!

That said I have just two things which bother me:

1. The context menu replicates the entire list of buttons which are already shown in the contextual area which feels very odd to me. Perhaps they

can be hidden with some CSS magic.

2. The three dot icon is the only button in the list which has no label what makes it difficult to recognize it as a clickable item. I think a descriptive

label like "More options" would helpful in that case.

#13 - 2018-05-24 12:05 - Go MAEDA

Bernhard Rohloff wrote:

1. The context menu replicates the entire list of buttons which are already shown in the contextual area which feels very odd to me. Perhaps

they can be hidden with some CSS magic.

 I can understand your opinion. However, some users, including me, may expect seeing same menu items with the context menu in other pages. In my

opinion, context menus should always have the same set of items for the same object. It is very consistent.

1. The three dot icon is the only button in the list which has no label what makes it difficult to recognize it as a clickable item. I think a

descriptive label like "More options" would helpful in that case.

 I think we don't have to add a label for the icon. The contextual area is already crowded with many icons, especially when you have admin privilege. I

think there is no problem even without a label for the icon because the 3-dots icon will be displayed in issues list in Redmine 4.0.0 (see #26655). In

addition, people see similar icon in many applications, so they are familiar with the kind of icons.

#14 - 2018-05-24 12:59 - Bernhard Rohloff

Bernhard Rohloff wrote:

That said I have just two things which bother me:
...

 Oh I forgot to say that I'm totally fine with the current implementation, anyway. My 2cts shouldn't be a show stopper for this patch. :-)

1+

#15 - 2018-05-25 02:52 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0

Thanks, Bernhard!

I am setting target version to 4.1.0.

#16 - 2018-05-29 02:52 - Go MAEDA

- Subject changed from Add context menu icon to issue's contextual area to Add right-click context menu to the contextual area of an issue

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Target version changed from 4.1.0 to 4.0.0

- Resolution set to Fixed

Committed. Thank you for your contribution.

#17 - 2018-05-30 11:08 - Enziin System

Please push to Github mirror.

Thanks.

#18 - 2018-06-13 23:10 - Marius BĂLTEANU

- File only_add_notes.png added

- File all_permissions.png added

Even if this feature is committed, I want to share my feedback:

1. I agree with Bernhard Rohloff regarding the entire list of buttons which looks very odd to me in some cases. I'm adding some examples below:

User only with permissions to add notes:

 only_add_notes.png 

2. User with full permissions have 5 duplicated items:

 all_permissions.png 

3. Edit, Copy and Delete items are rendered in all cases.

4. Some fields (ex: Description) cannot be changed from this "menu".

5. Issue status cannot be changed if the new status has some fields mandatory which are not already completed. You'll be thrown in the issue edit

page with some validations messages.

I'm not saying that this feature is not a step forward, but IMHO is insufficient considering that we are in the issue page context.

As I said in #28086#note-2, I'm considering that an inline editing feature for editable attributes (excepting status) is a better solution and for status

changes, a mechanism to show the next X possible statuses and on click on the next status, the mandatory fields should be shown in order to allow

the user to fill them in.

Again, I don't mind if this issue will be delivered in version#4.0.0, but I would like to find a better UI/UX solution in the near feature.

#19 - 2018-08-07 02:30 - Mizuki ISHIKAWA

- File fix-context-menu-on-issue.patch added

Thank you for your feedback.

This issue is closed, but I attach a patch to fix about some of the contents pointed out in this issue.

Do not display elements such as duplicate watch and copy on the issues/show context menu

Do not display icon for unauthorized users in issues / show

Fix to prevent icon style from collapsing
Add test

#20 - 2018-08-07 02:31 - Go MAEDA

- Status changed from Closed to Reopened

#21 - 2018-09-15 11:47 - Jean-Philippe Lang

- Target version deleted (4.0.0)

Thanks for your contributions. I agree that displaying duplicate actions in the dropdown menu is really odd. And there are still some issues even with

the last patch applied. For example, the menu will only be displayed if the user is allowed to change the issue status. Besides, if we introduce a

dropdown in this place, I think it would be nice to move some actions in the dropdown (eg: copy, delete) to free up some space in the contextual area.

All in all, I prefer to remove this from 4.0 and give it a bit more work.

#22 - 2020-03-16 00:46 - Marius BĂLTEANU

- Related to Feature #33153: UI feature to quickly change issue status added

Files

context-menu-for-issue-show@2x.png 38.7 KB 2018-05-21 Go MAEDA

Add-context-menu-icon-on-issue.patch 3.04 KB 2018-05-22 Mizuki ISHIKAWA

28829-screenshot@2x.png 65.4 KB 2018-05-22 Go MAEDA

28829-responsive-bug@2x.png 19.5 KB 2018-05-22 Go MAEDA

Add-context-menu-icon-on-issue-v2.patch 3.64 KB 2018-05-23 Mizuki ISHIKAWA

Add-context-menu-icon-on-issue-v3.patch 3.6 KB 2018-05-23 Mizuki ISHIKAWA

only_add_notes.png 29.3 KB 2018-06-13 Marius BĂLTEANU

all_permissions.png 90.1 KB 2018-06-13 Marius BĂLTEANU

fix-context-menu-on-issue.patch 6.25 KB 2018-08-07 Mizuki ISHIKAWA
